/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package swinghouseplan;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Enumeration;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.ListSelectionModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 *
 * @author naksabi
 */
class SwingHousePlanFrame extends JFrame {

    private JPanel jPanel = new JPanel();
    private DefaultListModel<Room> roomsModel = new DefaultListModel<>();
    private ListSelectionListener roomSelectionListener = new ListSelectionListener() {
        @Override
        public void valueChanged(ListSelectionEvent e) {
            Room selectedRoom = getSelectedRoom();
            if (selectedRoom != null) {
                selectedRoomX.removeChangeListener(spinnerChangeListener);
                selectedRoomY.removeChangeListener(spinnerChangeListener);
                selectedRoomWidth.removeChangeListener(spinnerChangeListener);
                selectedRoomLength.removeChangeListener(spinnerChangeListener);
                selectedRoomName.setText(selectedRoom.getName());
                selectedRoomX.setValue(selectedRoom.getX());
                selectedRoomY.setValue(selectedRoom.getY());
                selectedRoomWidth.setValue(selectedRoom.getWidth());
                selectedRoomLength.setValue(selectedRoom.getLength());
                selectedRoomX.addChangeListener(spinnerChangeListener);
                selectedRoomY.addChangeListener(spinnerChangeListener);
                selectedRoomWidth.addChangeListener(spinnerChangeListener);
                selectedRoomLength.addChangeListener(spinnerChangeListener);
                
                deleteRoomAction.setEnabled(true);
                jPanel.setVisible(true);
            } else {
                deleteRoomAction.setEnabled(false);
            }
        }
    };
    private ChangeListener spinnerChangeListener = new ChangeListener() {
        @Override
        public void stateChanged(ChangeEvent e) {
            Room selectedRoom = getSelectedRoom();
            if (selectedRoom != null) {
                selectedRoom.setX((int) selectedRoomX.getValue());
                selectedRoom.setY((int) selectedRoomY.getValue());
                selectedRoom.setWidth((int) selectedRoomWidth.getValue());
                selectedRoom.setLength((int) selectedRoomLength.getValue());
                repaint();
            }
        }
    };
    private JTextField selectedRoomName;
    private KeyListener roomNameListener = new KeyAdapter() {
        @Override
        public void keyTyped(KeyEvent e) {
            EventQueue.invokeLater(new Runnable() {
                @Override
                public void run() {
                    String roomName = selectedRoomName.getText();
                    Room selectedRoom = getSelectedRoom();
                    if (selectedRoom != null) {
                        selectedRoom.setName(roomName);
                        repaint();
                    }
                }
            });

        }
    };

    public SwingHousePlanFrame() {
        setTitle("Ház alaprajz");
        setLocation(32, 24);
        setSize(800, 600);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        // Default a BorderLayout()
        setLayout(new BorderLayout());

        add(new JPanel() {
            @Override
            public void paint(Graphics g) {
                paintHousePlan(g);
            }
        }, BorderLayout.CENTER);

        roomsList = new JList<>();
        roomsList.setPreferredSize(new Dimension(200, 25));
        roomsList.setModel(roomsModel);
        // Csak 1 elemet lehessen kiválasztani a listából egyszerre
        roomsList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        roomsList.addListSelectionListener(roomSelectionListener);
        add(new JScrollPane(roomsList), BorderLayout.WEST);

        
        //GridLayout --> Táblázatos megjelenítés
        jPanel.setLayout(new GridLayout(2, 5));
        jPanel.add(new JLabel("név"));
        jPanel.add(new JLabel("x koord"));
        jPanel.add(new JLabel("y koord"));
        jPanel.add(new JLabel("szélesség"));
        jPanel.add(new JLabel("hosszúság"));



        add(jPanel, BorderLayout.SOUTH);

        // Beégetett szobák:
        //roomsModel.addElement(new Room(10, 10, 140, 60, "Szoba1"));
        //roomsModel.addElement(new Room(150, 10, 40, 60, "Szoba2"));
        //roomsModel.addElement(new Room(10, 70, 180, 30, "Szoba3"));

        selectedRoomX = new JSpinner(new SpinnerNumberModel(0, 0, 1000, 1));
        selectedRoomY = new JSpinner(new SpinnerNumberModel(0, 0, 800, 1));
        selectedRoomWidth = new JSpinner(new SpinnerNumberModel(0, 0, 400, 1));
        selectedRoomLength = new JSpinner(new SpinnerNumberModel(0, 0, 300, 1));
        selectedRoomName = new JTextField();

        jPanel.add(selectedRoomName);
        jPanel.add(selectedRoomX);
        jPanel.add(selectedRoomY);
        jPanel.add(selectedRoomWidth);
        jPanel.add(selectedRoomLength);

        selectedRoomName.addKeyListener(roomNameListener);
        selectedRoomX.addChangeListener(spinnerChangeListener);
        selectedRoomY.addChangeListener(spinnerChangeListener);
        selectedRoomWidth.addChangeListener(spinnerChangeListener);
        selectedRoomLength.addChangeListener(spinnerChangeListener);

        JToolBar toolBar = new JToolBar();
        add(toolBar, BorderLayout.NORTH);
        toolBar.add(newRoomAction);
        toolBar.add(deleteRoomAction);
        
        JMenuBar menuBar = new JMenuBar();
        setJMenuBar(menuBar);
        menuBar.add(new JMenu("Fájl"));
        JMenu editMenu = new JMenu("Szerkesztés");
        menuBar.add(editMenu);
        editMenu.add(newRoomAction);
        editMenu.add(deleteRoomAction);
        
        deleteRoomAction.setEnabled(false);
        
        jPanel.setVisible(false);

    }
    
    private Action newRoomAction = new AbstractAction("Új szoba") {

        @Override
        public void actionPerformed(ActionEvent e) {
            Room room = new Room(10,10,60,40,"Új szoba");
            roomsModel.addElement(room);
            roomsList.setSelectedValue(room, true);
            repaint();
        }
    };
    private Action deleteRoomAction = new AbstractAction("Szoba törlés") {

        @Override
        public void actionPerformed(ActionEvent e) {
            Room room = roomsList.getSelectedValue();
            if(room != null){
                roomsModel.removeElement(room);
                jPanel.setVisible(false);
                repaint();                
            }

        }
    };
    
    private JList<Room> roomsList;
    private JSpinner selectedRoomX, selectedRoomY, selectedRoomWidth, selectedRoomLength;

    private void paintHousePlan(Graphics g) {
        Enumeration<Room> elements = roomsModel.elements();
        while (elements.hasMoreElements()) {
            Room room = elements.nextElement();
            if (getSelectedRoom() == room){
                g.setColor(Color.red);
            } else {
                g.setColor(Color.black);
            }
            g.drawRect(room.getX(), room.getY(), room.getWidth(), room.getLength());
            // szoba nevének rárajzolása
            g.drawString(room.getName(), room.getX() + 2, room.getY() + 12);
        }
    }

    public Room getSelectedRoom() {
        return roomsList.getSelectedValue();
    }
}
